import java.net.*;
import java.io.*;
import java.security.*;
import javax.net.ssl.*;

public class HttpsClient {
    
  public static void main(String[] args) {
    
    if (args.length == 0) {
      System.out.println("Usage: java HttpsClient host dir port");
      return;
    }       
    
    //int port = 443; // default https port
    String host = args[0];
    String dir = args[1];
    int port = Integer.parseInt(args[2]);

    // a activer pour se connecter a des sites sans certifs sign'es par des CA
    // il faut avoir mis le certificat ad-hoc dans trustedstore via 
    // keytool -import -file fichier_certif -keystore trustedstore
    System.setProperty("javax.net.ssl.trustStore","trustedstore");
    System.setProperty("javax.net.ssl.trustStorePasswd","123456");

    try {     
      
      SSLSocketFactory factory 
       = (SSLSocketFactory) SSLSocketFactory.getDefault();
       
      SSLSocket socket = (SSLSocket) factory.createSocket(host, port);

      Writer out = new OutputStreamWriter(socket.getOutputStream());
      // https requires the full URL in the GET line
      out.write("GET "+dir+" HTTP/1.0\r\n");
      out.write("User-Agent: Custom/0.01\r\n");
      out.write("Host: "+host+":"+port+"\r\n");
      out.write("\r\n");
      out.flush(); 

      // read response
      BufferedReader in = new BufferedReader(
       new InputStreamReader(socket.getInputStream()));
      int c;
      while ((c = in.read()) != -1) {
        System.out.write(c);
      }
      
      out.close();                  
      in.close();
      socket.close();
      
    } 
    catch (IOException e) {
      System.err.println(e);
    }
    
  }
  
}
