import java.net.*;
import java.io.*;
import java.security.*;
import javax.net.ssl.*;

public class HttpsProxyClient {
    
  public static void main(String[] args) {
    
    if (args.length == 0) {
      System.out.println("Usage: java HttpsProxyClient host dir");
      return;
    }       
    
    int port = 443; // default https port
    String host = args[0];
    String dir = args[1];
    
    try {     
      
      // 1) on contacte le proxy

      Socket s = new Socket(InetAddress.getByName("fructidor"),3128); 
      Writer sout = new OutputStreamWriter(s.getOutputStream());   
      BufferedReader sin = new BufferedReader(
          new InputStreamReader(s.getInputStream()));

      // 2) on lui demande de relayer vers le serveur voulu      

      sout.write("CONNECT "+host+":"+port+" HTTP/1.0\r\n");
      sout.write("\r\n");
      sout.flush(); 

      // 3) on recoit la reponse du proxy (normalement un 200)

      while (sin.readLine().length() != 0) {}

      // 4) maintenant, on ouvre une SSLSocket par dessus la première

      SSLSocketFactory factory 
	  = (SSLSocketFactory) SSLSocketFactory.getDefault();
      SSLSocket socket = (SSLSocket) factory.createSocket(s,host,port,true);

      Writer out = new OutputStreamWriter(socket.getOutputStream());
      // https requires the full URL in the GET line
      out.write("GET "+dir+" HTTP/1.0\r\n");
      out.write("User-Agent: Custom/0.01\r\n");
      out.write("Host: "+host+":"+port+"\r\n");
      out.write("\r\n");
      out.flush(); 

      // read response
      BufferedReader in = new BufferedReader(
       new InputStreamReader(socket.getInputStream()));
      int c;
      while ((c = in.read()) != -1) {
        System.out.write(c);
      }
      
      out.close();                  
      in.close();
      socket.close();
      
    } 
    catch (IOException e) {
      System.err.println(e);
    }
    
  }
  
}
