import javax.net.ssl.*;
import java.io.*;
import java.net.*;
import java.util.*;

class HttpsServer extends Thread {
    
    private Socket mysock; 
    
    HttpsServer (Socket s) { mysock = s; }

    public void run () { 
	try {
	    
	    // Si l'on veut toujours repondre le meme message, 
	    // pas besoin de la requete, mais regardons-la quand meme...

	    BufferedReader in = new BufferedReader(new InputStreamReader(mysock.getInputStream()));
	    // premiere ligne de la requete
	    String line = in.readLine (); 
	    if (line == null) { 
		System.out.println("requete vide ?!"); 
		return; 
	    }
	    String[] parts = line.split(" "); 
	    if (parts.length != 3) { 
		System.out.println("requete malformee ?!"); 
		return; 
	    }
	    // URI de la requete
	    String requete = parts[1]; 

	    // on imprime toute la requete sur la console
	    while (line.length() != 0) {
		System.out.println("REQUETE: "+line); 
		line = in.readLine(); 
	    }
	    System.out.println();
	    
	    // Reponse
	    PrintStream output = new PrintStream(mysock.getOutputStream());
	    output.print("HTTP/1.0 200 OK\r\n");
	    output.print("Server: lemien/java 0.001\r\n");
	    // Pour etre conforme, il faudrait aussi renvoyer un Content-length...
	    output.print("\r\n"); 
	    output.print
		("<html><body>\n"+
		 "<h1>Bonjour Monde</h1>\n"+
		 "<h2>Voici votre message confidentiel</h2>\n"+
		 "Votre requete: "+requete+"<br />\n"+
		 "Quelques information: <br />\n"+
		 "Date: "+(new Date())+"<br />\n"+
		 "Serveur: "+InetAddress.getLocalHost()+"<br />\n"+
		 "Version de Java: "+
		 System.getProperty("java.version")+"<br />\n"+
		 "Systeme d'exploitation: "+
		 System.getProperty("os.name")+" "+
		 System.getProperty("os.version")+"<br />\n"+
		 "Proprietaire du serveur: "+
		 System.getProperty("user.name")+"<br />\n"+
		 "</body></html>\n"); 

	    mysock.close();

	} 
	catch (Exception e) { System.out.println(e); System.exit(1); }

    }

	
    public static void main(String argv[]) throws Exception {
	int port = 0; 
	try {
	    port = Integer.parseInt(argv[0]);
	} catch (Exception e) {
	    System.out.println("usage: java HttpServer NumeroDePort"); 
	    System.exit(0);
	}       

	System.setProperty("javax.net.ssl.keyStore", "/home/letouzey/reseau/td10/mykeystore");
	System.setProperty("javax.net.ssl.keyStorePassword", "abcdef");

	SSLServerSocketFactory sf =
                    (SSLServerSocketFactory) SSLServerSocketFactory.getDefault();
	SSLServerSocket s = (SSLServerSocket) sf.createServerSocket(port);
	while (true) { 
	    System.out.println("accepte...");
	    HttpsServer r = new HttpsServer(s.accept()); 
	    System.out.println("sous-traite...");
	    r.start(); 
	}

    }
}

